import { WireType } from "@protobuf-ts/runtime";
import { UnknownFieldHandler } from "@protobuf-ts/runtime";
import { reflectionMergePartial } from "@protobuf-ts/runtime";
import { MessageType } from "@protobuf-ts/runtime";
import { AddressVoucher } from "../../common/vouchers/v1/vouchers_pb.js";
import { FailedRedemptionSchedule } from "./insurance_pb.js";
import { RedemptionSchedule } from "./insurance_pb.js";
import { InsuranceFund } from "./insurance_pb.js";
import { Params } from "./insurance_pb.js";
class GenesisState$Type extends MessageType {
  constructor() {
    super("injective.insurance.v1beta1.GenesisState", [
      { no: 1, name: "params", kind: "message", T: () => Params, options: { "gogoproto.nullable": false } },
      { no: 2, name: "insurance_funds", kind: "message", repeat: 2, T: () => InsuranceFund, options: { "gogoproto.nullable": false } },
      { no: 3, name: "redemption_schedule", kind: "message", repeat: 2, T: () => RedemptionSchedule, options: { "gogoproto.nullable": false } },
      {
        no: 4,
        name: "next_share_denom_id",
        kind: "scalar",
        T: 4,
        L: 0
        /*LongType.BIGINT*/
      },
      {
        no: 5,
        name: "next_redemption_schedule_id",
        kind: "scalar",
        T: 4,
        L: 0
        /*LongType.BIGINT*/
      },
      { no: 6, name: "failed_redemption_schedules", kind: "message", repeat: 2, T: () => FailedRedemptionSchedule, options: { "gogoproto.nullable": false } },
      {
        no: 7,
        name: "next_failed_redemption_schedule_id",
        kind: "scalar",
        T: 4,
        L: 0
        /*LongType.BIGINT*/
      },
      { no: 8, name: "vouchers", kind: "message", repeat: 2, T: () => AddressVoucher, options: { "gogoproto.nullable": false } }
    ]);
  }
  create(value) {
    const message = globalThis.Object.create(this.messagePrototype);
    message.insuranceFunds = [];
    message.redemptionSchedule = [];
    message.nextShareDenomId = 0n;
    message.nextRedemptionScheduleId = 0n;
    message.failedRedemptionSchedules = [];
    message.nextFailedRedemptionScheduleId = 0n;
    message.vouchers = [];
    if (value !== void 0)
      reflectionMergePartial(this, message, value);
    return message;
  }
  internalBinaryRead(reader, length, options, target) {
    let message = target ?? this.create(), end = reader.pos + length;
    while (reader.pos < end) {
      let [fieldNo, wireType] = reader.tag();
      switch (fieldNo) {
        case /* injective.insurance.v1beta1.Params params */
        1:
          message.params = Params.internalBinaryRead(reader, reader.uint32(), options, message.params);
          break;
        case /* repeated injective.insurance.v1beta1.InsuranceFund insurance_funds */
        2:
          message.insuranceFunds.push(InsuranceFund.internalBinaryRead(reader, reader.uint32(), options));
          break;
        case /* repeated injective.insurance.v1beta1.RedemptionSchedule redemption_schedule */
        3:
          message.redemptionSchedule.push(RedemptionSchedule.internalBinaryRead(reader, reader.uint32(), options));
          break;
        case /* uint64 next_share_denom_id */
        4:
          message.nextShareDenomId = reader.uint64().toBigInt();
          break;
        case /* uint64 next_redemption_schedule_id */
        5:
          message.nextRedemptionScheduleId = reader.uint64().toBigInt();
          break;
        case /* repeated injective.insurance.v1beta1.FailedRedemptionSchedule failed_redemption_schedules */
        6:
          message.failedRedemptionSchedules.push(FailedRedemptionSchedule.internalBinaryRead(reader, reader.uint32(), options));
          break;
        case /* uint64 next_failed_redemption_schedule_id */
        7:
          message.nextFailedRedemptionScheduleId = reader.uint64().toBigInt();
          break;
        case /* repeated injective.common.vouchers.v1.AddressVoucher vouchers */
        8:
          message.vouchers.push(AddressVoucher.internalBinaryRead(reader, reader.uint32(), options));
          break;
        default:
          let u = options.readUnknownField;
          if (u === "throw")
            throw new globalThis.Error(`Unknown field ${fieldNo} (wire type ${wireType}) for ${this.typeName}`);
          let d = reader.skip(wireType);
          if (u !== false)
            (u === true ? UnknownFieldHandler.onRead : u)(this.typeName, message, fieldNo, wireType, d);
      }
    }
    return message;
  }
  internalBinaryWrite(message, writer, options) {
    if (message.params)
      Params.internalBinaryWrite(message.params, writer.tag(1, WireType.LengthDelimited).fork(), options).join();
    for (let i = 0; i < message.insuranceFunds.length; i++)
      InsuranceFund.internalBinaryWrite(message.insuranceFunds[i], writer.tag(2, WireType.LengthDelimited).fork(), options).join();
    for (let i = 0; i < message.redemptionSchedule.length; i++)
      RedemptionSchedule.internalBinaryWrite(message.redemptionSchedule[i], writer.tag(3, WireType.LengthDelimited).fork(), options).join();
    if (message.nextShareDenomId !== 0n)
      writer.tag(4, WireType.Varint).uint64(message.nextShareDenomId);
    if (message.nextRedemptionScheduleId !== 0n)
      writer.tag(5, WireType.Varint).uint64(message.nextRedemptionScheduleId);
    for (let i = 0; i < message.failedRedemptionSchedules.length; i++)
      FailedRedemptionSchedule.internalBinaryWrite(message.failedRedemptionSchedules[i], writer.tag(6, WireType.LengthDelimited).fork(), options).join();
    if (message.nextFailedRedemptionScheduleId !== 0n)
      writer.tag(7, WireType.Varint).uint64(message.nextFailedRedemptionScheduleId);
    for (let i = 0; i < message.vouchers.length; i++)
      AddressVoucher.internalBinaryWrite(message.vouchers[i], writer.tag(8, WireType.LengthDelimited).fork(), options).join();
    let u = options.writeUnknownFields;
    if (u !== false)
      (u == true ? UnknownFieldHandler.onWrite : u)(this.typeName, message, writer);
    return writer;
  }
}
const GenesisState = new GenesisState$Type();
export {
  GenesisState
};
